{################################################################################}
{# Copyright (c) 2022-2024 Bayerische Motoren Werke Aktiengesellschaft (BMW AG) #}
{#                                                                              #}
{# This program and the accompanying materials are made available under the     #}
{# terms of the Eclipse Public License 2.0 which is available at                #}
{# http://www.eclipse.org/legal/epl-2.0.                                        #}
{#                                                                              #}
{# SPDX-License-Identifier: EPL-2.0                                             #}
{################################################################################}
{% extends "Storyboard/ByValueCondition.h.j2" %}

{#############################################################################}


{% block includes %}
    #include "Utils/EntityBroker.h"
    #include "Storyboard/ByEntityCondition/{{ node.umlClass.name }}_impl.h"
    #include <agnostic_behavior_tree/action_node.h>
    #include <cassert>
    {% for dep in node.dependencies %}
    #include {{dep.include}}
    {% endfor %}
{% endblock %}

{#############################################################################}

{% block tick %}
    yase::NodeStatus tick() override
    {
        assert(impl_);

        const auto is_satisfied = impl_->IsSatisfied();

        if (is_satisfied)
        {
            if (entityBroker_)
            {
	        entityBroker_->add_triggering(triggeringEntity_);
            }
            return yase::NodeStatus::kSuccess;
        }

        return yase::NodeStatus::kRunning;
    };
{% endblock %}

{#############################################################################}

{% block blackboard_getter_special %}
triggeringEntity_ = blackboard.get<std::string>("TriggeringEntity");
if (blackboard.exists("EntityBroker"))
{
    entityBroker_ = blackboard.get<EntityBroker::Ptr>("EntityBroker");
}
{% endblock %}

{#############################################################################}

{% block implementation_values_special %}
     triggeringEntity_,
{% endblock %}

{#############################################################################}

{% block member_definitions_special %}
std::string triggeringEntity_;
EntityBroker::Ptr entityBroker_{nullptr};
{% endblock %}
